package com.ruoyi.platform.mapper;

import com.ruoyi.platform.domain.DatasetVersion;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * (DatasetVersion)表数据库访问层
 *
 * @author Xidaray
 * @since 2024-01-03 16:57:12
 */
public interface DatasetVersionDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    DatasetVersion queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param datasetVersion 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<DatasetVersion> queryAllByLimit(@Param("datasetVersion") DatasetVersion datasetVersion, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param datasetVersion 查询条件
     * @return 总行数
     */
    long count(@Param("datasetVersion") DatasetVersion datasetVersion);

    /**
     * 新增数据
     *
     * @param datasetVersion 实例对象
     * @return 影响行数
     */
    int insert(@Param("datasetVersion") DatasetVersion datasetVersion);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<DatasetVersion> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<DatasetVersion> entities);



    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<DatasetVersion> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<DatasetVersion> entities);

    /**
     * 修改数据
     *
     * @param datasetVersion 实例对象
     * @return 影响行数
     */
    int update(@Param("datasetVersion") DatasetVersion datasetVersion);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<DatasetVersion> queryByDatasetId(Integer datasetId);

    DatasetVersion
    queryByDatasetVersion(@Param("datasetVersion") DatasetVersion datasetVersion);

    List<DatasetVersion> queryAllByDatasetVersion(@Param("datasetId") Integer datasetId, @Param("version") String version);


}

